package application;

import java.util.ArrayList;

public class Job
{

	private int jobnumber;

	private float jobvalue;

	private String jobtime;

	private ArrayList<Integer> positionenQuantity;

	private ArrayList<String> positionenName;

	private ArrayList<Float> positionenValue;

	private ArrayList<String> positionenCat;

	public Job(int pJobnumber, String pTime)
	{
		this.jobnumber = pJobnumber;
		this.jobtime = pTime;

		System.out
				.println("Neuer Job: " + this.jobnumber + " Time: " + this.jobtime);

		positionenQuantity = new ArrayList<Integer>();
		positionenName = new ArrayList<String>();
		positionenValue = new ArrayList<Float>();
		positionenCat = new ArrayList<String>();

		// System.out.println("Größe: " + positionenName.size());

	}

	public int getJobnumber()
	{
		return this.jobnumber;
	}

	public String getJobtime()
	{
		return this.jobtime;
	}

	public float getJobValue()
	{

		return this.jobvalue;
	}

	public void addPosition(String pPositionenName, float pPositionenValue,
			String pPositionenCat)
	{
		// System.out.println("addName");

		for (int i = 0; i < positionenName.size(); i++) {
			if (positionenName.get(i).equals(pPositionenName)) {
				// Item is already in list, increase quantity
				positionenQuantity.set(i, positionenQuantity.get(i) + 1);
				// System.out.println("Item exists, increasing quantity");
				return;
			}
		}

		positionenName.add(pPositionenName);
		positionenValue.add(pPositionenValue);
		positionenCat.add(pPositionenCat);
		positionenQuantity.add(1);

		calcJobValue();
	}

	public void printJobOnConsole()
	{

		System.out.println("---------------------------------------------");
		System.out.println("JobNummer: " + jobnumber);
		System.out.println("---------------------------------------------");

		// System.out.println("Größe: " + positionenName.size());

		for (int i = 0; i < positionenName.size(); i++) {

			System.out.println(
					positionenQuantity.get(i) + " " + positionenName.get(i) + " "
							+ positionenValue.get(i) + " " + positionenCat.get(i));
			/*
			 * System.out.println("i is: " + i);
			 * System.out.println(positionenName.get(i));
			 * System.out.println(positionenQuantity.get(i));
			 */

		}

		System.out.println("---------------------------------------------");

	}

	public ArrayList<tableDataCurrentOrder> getCurrentJobPositionen()
	{

		ArrayList<tableDataCurrentOrder> jobitems = new ArrayList<tableDataCurrentOrder>();

		for (int i = 0; i < positionenName.size(); i++) {

			tableDataCurrentOrder tmp = new tableDataCurrentOrder(
					positionenName.get(i), positionenQuantity.get(i));

			jobitems.add(tmp);

		}

		return jobitems;
	}

	private void calcJobValue()
	{

		for (int i = 0; i < positionenValue.size(); i++) {

			jobvalue = jobvalue
					+ (positionenQuantity.get(i) * positionenValue.get(i));

		}

	}

	public String createPosQuantityDBString()
	{
		String tmp = "";
		for (int i = 0; i < positionenName.size(); i++) {

			tmp = tmp + ";" + positionenQuantity.get(i);
		}
		return tmp;
	}
	
	public String createPosNameDBString()
	{
		String tmp = "";
		for (int i = 0; i < positionenName.size(); i++) {

			tmp = tmp + ";" + positionenName.get(i);
		}
		return tmp;
	}
	
	public String createPosValueDBString()
	{
		String tmp = "";
		for (int i = 0; i < positionenName.size(); i++) {

			tmp = tmp + ";" + positionenValue.get(i);
		}
		return tmp;
	}
	
	public String createPosCatDBString()
	{
		String tmp = "";
		for (int i = 0; i < positionenName.size(); i++) {

			tmp = tmp + ";" + positionenCat.get(i);
		}
		return tmp;
	}

}
